'' =================================================================================================
''
''   File....... DEX_Prop.spin
''   Purpose.... DEX Reader
''   Author..... Don Merchant
''               -- see below for terms of use
''   E-mail..... 
''   Started.... 06 SEP 2011
''   Updated.... 08 SEP 2011  This version excluded PST control and prints data in ASCII format
''
'' =================================================================================================


con

  _clkmode        = xtal1 + pll16x                      ' Feedback and PLL multiplier
  _xinfreq        = 5_000_000                           ' External oscillator = 5 MHz


  MS_001   = 80_000_000 / 1_000                         ' ticks in 1ms 

  DEX_TX = 0                                            ' DEX -> VMC
  DEX_RX = 1                                            ' VMC -> DEX

  

obj

  dex   : "fullduplexserialplus"                                       
  term  : "fullduplexserialplus"


var

  byte  dexstrng[24], dexdata[245]

  
pub main   | i, d, inx 

  term.start(31, 30, %0000, 115_200)                    ' start terminal (use PST)
  dex.start(1, 0, %0000, 9_600)                         ' start DEX read

  pause (1000)                                          ' pause for PST to start
  
  
    dex.tx($05)                                         ' send ENQ to start
    term.str(string("Start DEX_Prop Ver 0.2", 13))
    i := dex.rxtime(100)                                ' look for response from VMC
    if i == $10                                         ' if DLE received from VMC start handshake
       i := dex.rx
       if i == $30
          term.str(string("Start 1st Handshake", 13))
          dex.tx($10)                                   ' send DLE
          pause(15)
          dex.tx($01)                                   ' send SOH
          pause(15)
          dex.str(string("1234567890RR01L01"))          ' send string
          pause(15)
          dex.tx($10)                                   ' send DLE
          pause(15)
          dex.tx($03)                                   ' send ETX
          pause(15)
          dex.tx($DE)                                   ' send upper byte of CRC checksum
          pause(15)
          dex.tx($4D)                                   ' send lower byte of CRC checksum
          pause(15)
       else
          term.str(string(2, 1, 3, "No response"))      ' If no DLE received from VMC then indicate no communication
          
    i := dex.rx                                         ' In this section we look for a DLE response from the VMC to end first handshake
     
    if i == $15
       term.str(string(2, 1, 5, "NAK"))                 ' if checksum isn't right let us know
    else
      if i == $10
         i := dex.rx
         if i == $31
            term.str(string("First Handshake Successful", 13))
            dex.tx($04)                                  ' send EOT
      else
          term.str(string(2, 1, 5, "Didn't recognize DLE..."))

    i := dex.rx

    if i == $05                                         ' look for ENQ
       term.str(string("Start 2nd Handshake"))
       dex.tx($10)                                      ' acknowledge the ENQ by sending DLE 0
       dex.tx($30)     
    else
       term.str(string(2, 1, 7, "Didn't recognize ENQ..."))

    pause(15)
  
    inx := 1                                            ' receive id data from VMC but do nothing with it
    repeat 24
      i := dex.rxtime(40)
      dexstrng[inx] := i
      'term.tx(dexstrng[inx])   
      inx += 1

    term.tx(13)
    dex.tx($10)
    dex.tx($31)
    
    i := dex.rxtime(100)                                ' look for response from VMC
    if i == $04                                         ' if DLE received from VMC start handshake
       term.str(string("Second Handshake Successful", 13))
       i := dex.rx
       if i == $05
          term.str(string("Begin DEX dump from VMC...", 13))
          dex.tx($10)
          dex.tx($30)

    inx := 1                                            ' initialize index counter to 1
                                                        
    i := dex.rxtime(20)                                 ' receive in dex data and assign it to variable i
      if i == $10                                       ' check to see if byte is DLE
        i := dex.rx                                     ' receive in next byte
         if i == $02                                    ' check to see if next byte is STX. if so start repeat loop
            repeat until i == $10                       ' do repeat until byte received is DLE then quit
              i := dex.rx                               ' receive in nexy byte and assign to variable i
              dexdata[inx] := i                         ' assign received byte i to dexdata variable indexed by index counter inx
              term.tx(dexdata[inx])                     ' send data byte to terminal for printing
              inx += 1                                  ' increment index counter
              
    dex.tx($10)                                         ' send ACK - DLE 1
    dex.tx($31)                                         ' ACK's alternate between DLE 0 and DLE 1

    inx := 1                                            ' repeat process again for next batch of data
    
    i := dex.rxtime(20)
      if i == $10
         i := dex.rx
         if i == $02
            repeat until i == $10
              i := dex.rx
              dexdata[inx] := i
              term.tx(dexdata[inx])
              inx += 1
              
    dex.tx($10)                                         ' send ACK - DLE 0
    dex.tx($30)

    inx := 1                                            ' repeat process again for next batch of data
    
    i := dex.rxtime(250)
      if i == $10
         i := dex.rx
         if i == $02
            repeat until i == $10
              i := dex.rx
              dexdata[inx] := i
              term.tx(dexdata[inx])
              inx += 1

    dex.tx($10)
    dex.tx($31)

    inx := 1
    
    i := dex.rxtime(250)
      if i == $10
         i := dex.rx
         if i == $02
            repeat until i == $10
              i := dex.rx
              dexdata[inx] := i
              term.tx(dexdata[inx])
              inx += 1

    dex.tx($10)
    dex.tx($30)

    inx := 1
    
    i := dex.rxtime(250)
      if i == $10
         i := dex.rx
         if i == $02
            repeat until i == $10
              i := dex.rx
              dexdata[inx] := i
              term.tx(dexdata[inx])
              inx += 1

    dex.tx($10)
    dex.tx($31)

    inx := 1
    
    i := dex.rxtime(250)
      if i == $10
         i := dex.rx
         if i == $02
            repeat until i == $10
              i := dex.rx
              dexdata[inx] := i
              term.tx(dexdata[inx])
              inx += 1

    dex.tx($10)
    dex.tx($30)

    inx := 1
    
    i := dex.rxtime(250)
      if i == $10
         i := dex.rx
         if i == $02
            repeat until i == $10
              i := dex.rx
              dexdata[inx] := i
              term.tx(dexdata[inx])
              inx += 1

    term.tx(13)
    dex.tx($10)
    dex.tx($31)

    i := dex.rx                                         ' look for EOT to end routine                               
    if i == $04
       term.str(string(" DEX finished"))
           

                         
pub pause(ms) | t

'' Delays program for ms milliseconds

  t := cnt
  repeat ms
    waitcnt(t += MS_001)
  